/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.java.html.canvas;

import java.util.ServiceLoader;

/**
 *
 * @author antonepple
 */
public abstract class GraphicsEnvironment {

    private static GraphicsEnvironment DEFAULT;

    public GraphicsEnvironment getDefault() {
        if (DEFAULT == null) {
            ServiceLoader<GraphicsEnvironment> loader = ServiceLoader.load(GraphicsEnvironment.class);
            DEFAULT = loader.iterator().next();
        }
        return DEFAULT == null ? getDummyInstance() : DEFAULT;
    }

    public abstract Image getImageForPath(String path);
    
    public abstract LinearGradient createLinearGradient();
    
    public abstract Pattern createPattern();
    
    public abstract RadialGradient createRadialGradient();
    
    public abstract TextMetrics createTextMetrics();
    
    private GraphicsEnvironment getDummyInstance() {
        
        return new GraphicsEnvironment() {

            @Override
            public Image getImageForPath(String path) {
               return new Image() {

                   @Override
                   public int getHeight() {
                     return 0;
                   }

                   @Override
                   public int getWidth() {
                       return 0;
                   }
               };
            }

            @Override
            public LinearGradient createLinearGradient() {
                return new LinearGradient() {

                    @Override
                    public void addColorStop(double position, String color) {
                      
                    }
                };
            }

            @Override
            public Pattern createPattern() {
               return new Pattern() {
};
            }

            @Override
            public RadialGradient createRadialGradient() {
                return new RadialGradient() {

                    @Override
                    public void addColorStop(double position, String color) {
                        
                    }
                };
            }

            @Override
            public TextMetrics createTextMetrics() {
                return new TextMetrics() {

                    @Override
                    public double getHeight() {
                        return 0;
                    }

                    @Override
                    public double getWidth() {
                        return 0;
                    }
                };
            }
        };
    }
    
    
}
